var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "commands/getDocumentWithMetadataCommand"], function(require, exports, commandBase, getDocumentWithMetadataCommand) {
    var backupDatabaseCommand = (function (_super) {
        __extends(backupDatabaseCommand, _super);
        function backupDatabaseCommand(db, backupLocation, updateBackupStatus) {
            _super.call(this);
            this.db = db;
            this.backupLocation = backupLocation;
            this.updateBackupStatus = updateBackupStatus;
        }
        backupDatabaseCommand.prototype.execute = function () {
            var _this = this;
            var result = $.Deferred();

            this.query('/admin/databases/' + this.db.name, null, null).fail(function (response) {
                return result.reject(response);
            }).done(function (doc) {
                var args = {
                    BackupLocation: _this.backupLocation,
                    DatabaseDocument: doc
                };
                _this.post('/admin/backup', JSON.stringify(args), _this.db, { dataType: 'text' }).fail(function (response) {
                    return result.reject(response);
                }).done(function () {
                    _this.getBackupStatus(result);
                });
            });

            return result;
        };

        backupDatabaseCommand.prototype.getBackupStatus = function (result) {
            var _this = this;
            new getDocumentWithMetadataCommand("Raven/Backup/Status", this.db).execute().fail(function (response) {
                return result.reject(response);
            }).done(function (backupStatus) {
                _this.updateBackupStatus(backupStatus);
                if (backupStatus.IsRunning) {
                    setTimeout(function () {
                        return _this.getBackupStatus(result);
                    }, 1000);
                }
            });
        };
        return backupDatabaseCommand;
    })(commandBase);

    
    return backupDatabaseCommand;
});
