﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var deleteDestinationCommand = (function (_super) {
        __extends(deleteDestinationCommand, _super);
        function deleteDestinationCommand(fs, destination) {
            _super.call(this);
            this.fs = fs;
            this.destination = destination;
        }
        deleteDestinationCommand.prototype.execute = function () {
            var _this = this;
            var result = $.Deferred();

            var dtos = [];

            this.query("/config", { name: "Raven/Synchronization/Destinations" }, this.fs).done(function (data) {
                if (data && data.hasOwnProperty('destination')) {
                    var value = data['destination'];
                    if (!(value instanceof Array))
                        value = [value];

                    var dtos = value.map(function (x) {
                        return JSON.parse(x);
                    }).filter(function (x) {
                        return x.ServerUrl != _this.destination;
                    });

                    data.destination = dtos.map(function (x) {
                        return JSON.stringify(x);
                    });

                    var url = "/config?name=" + encodeURIComponent("Raven/Synchronization/Destinations");
                    _this.put(url, JSON.stringify(data), _this.fs).done(function () {
                        return result.resolve(data);
                    });
                }
            });

            return result;
        };
        return deleteDestinationCommand;
    })(commandBase);

    
    return deleteDestinationCommand;
});
