﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var deleteFilesCommand = (function (_super) {
        __extends(deleteFilesCommand, _super);
        function deleteFilesCommand(fileIds, fs) {
            _super.call(this);
            this.fileIds = fileIds;
            this.fs = fs;
        }
        deleteFilesCommand.prototype.execute = function () {
            var _this = this;
            var deletionTasks = [];
            for (var i = 0; i < this.fileIds.length; i++) {
                var deleteCommand = this.deleteFile(this.fileIds[i]);
                deletionTasks.push(deleteCommand);
            }

            var successMessage = this.fileIds.length > 1 ? "Deleted " + this.fileIds.length + " files" : "Deleted " + this.fileIds[0];

            var combinedTask = $.when(deletionTasks).done(function (x) {
                return _this.reportSuccess(successMessage);
            }).fail(function (response) {
                return _this.reportError("Failed to delete files", response.responseText, response.statusText);
            });

            return combinedTask;
        };

        deleteFilesCommand.prototype.deleteFile = function (fileId) {
            var url = "/files/" + fileId;
            return this.del(url, null, this.fs);
        };
        return deleteFilesCommand;
    })(commandBase);

    
    return deleteFilesCommand;
});
