﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var getConfigurationByKeyCommand = (function (_super) {
        __extends(getConfigurationByKeyCommand, _super);
        function getConfigurationByKeyCommand(fs, name) {
            _super.call(this);
            this.fs = fs;
            this.name = name;
        }
        getConfigurationByKeyCommand.prototype.execute = function () {
            var _this = this;
            var url = "/config";
            var args = {
                name: this.name
            };

            var task = $.Deferred();
            this.query(url, args, this.fs).done(function (data) {
                var array = new Array();
                for (var key in data) {
                    if (data.hasOwnProperty(key)) {
                        var value = data[key];
                        if (value instanceof Array) {
                            array.push(new Pair(key, value));
                        } else {
                            array.push(new Pair(key, new Array(value)));
                        }
                    }
                }

                task.resolve(array);
            }).fail(function (response) {
                return _this.reportError("Failed to retrieve filesystem configuration key. Does exist in this filesystem?", response.responseText, response.statusText);
            });

            return task;
        };
        return getConfigurationByKeyCommand;
    })(commandBase);

    
    return getConfigurationByKeyCommand;
});
