﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "common/pagedResultSet", "models/filesystem/file"], function(require, exports, commandBase, pagedResultSet, file) {
    var searchByQueryCommand = (function (_super) {
        __extends(searchByQueryCommand, _super);
        function searchByQueryCommand(fs, queryParameter, skip, take, sortParameter) {
            _super.call(this);
            this.fs = fs;
            this.queryParameter = queryParameter;
            this.skip = skip;
            this.take = take;
            this.sortParameter = sortParameter;
        }
        searchByQueryCommand.prototype.execute = function () {
            var filesTask = this.fetchFiles();
            var totalResultsTask = this.fetchTotalResultCount();

            var doneTask = $.Deferred();
            var combinedTask = $.when(filesTask, totalResultsTask);

            combinedTask.done(function (filesResult, resultsCount) {
                return doneTask.resolve(new pagedResultSet(filesResult, resultsCount));
            });
            combinedTask.fail(function (xhr) {
                return doneTask.reject(xhr);
            });

            return doneTask;
        };

        searchByQueryCommand.prototype.fetchFiles = function () {
            var args = {
                query: this.queryParameter,
                start: this.skip,
                pageSize: this.take
            };

            var url = "/search";
            var filesSelector = function (results) {
                return results.Files.map(function (d) {
                    return new file(d);
                });
            };
            return this.query(url, args, this.fs, filesSelector);
        };

        searchByQueryCommand.prototype.fetchTotalResultCount = function () {
            var url = "/stats";
            var countSelector = function (dto) {
                return dto.FileCount;
            };
            return this.query(url, null, this.fs, countSelector);
        };
        return searchByQueryCommand;
    })(commandBase);

    
    return searchByQueryCommand;
});
