﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "models/uploadItem"], function(require, exports, commandBase, uploadItem) {
    var uploadFileToFilesystemCommand = (function (_super) {
        __extends(uploadFileToFilesystemCommand, _super);
        function uploadFileToFilesystemCommand(source, uploadId, fs, progressHandlingFunction, reportUploadProgress) {
            if (typeof reportUploadProgress === "undefined") { reportUploadProgress = true; }
            _super.call(this);
            this.source = source;
            this.uploadId = uploadId;
            this.fs = fs;
            this.reportUploadProgress = reportUploadProgress;
        }
        uploadFileToFilesystemCommand.prototype.execute = function () {
            var _this = this;
            if (this.reportUploadProgress) {
                this.reportInfo("File " + this.source.name + "queued for upload...");
            }

            var url = '/files?name=' + this.source.name + '&uploadId=' + this.uploadId;

            var customHeaders = {
                'RavenFS-Size': this.source.size
            };

            var deferred = $.Deferred();

            var jQueryOptions = {
                headers: customHeaders,
                processData: false,
                xhr: function () {
                    var myXhr = $.ajaxSettings.xhr();
                    if (myXhr.upload) {
                        myXhr.upload.addEventListener('progress', this.progressHandlingFunction, false);
                    }
                    if (myXhr.upload) {
                        myXhr.upload.onprogress = this.progressHandlingFunction;
                    }
                    return myXhr;
                },
                cache: false,
                contentType: false,
                dataType: ''
            };

            var uploadTask = this.put(url, this.source, this.fs, jQueryOptions);

            if (this.reportUploadProgress) {
                uploadTask.done(function () {
                    _this.reportSuccess("Uploaded " + _this.source.name);
                    return deferred.resolve(new uploadItem(_this.uploadId, _this.source.name, "Uploaded", _this.fs));
                });
                uploadTask.fail(function (response) {
                    _this.reportError("Failed to upload " + _this.source.name, response.responseText, response.statusText);
                    return deferred.reject(new uploadItem(_this.uploadId, _this.source.name, "Failed", _this.fs));
                });
            }

            return deferred;
        };
        return uploadFileToFilesystemCommand;
    })(commandBase);

    
    return uploadFileToFilesystemCommand;
});
