var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "models/database"], function(require, exports, commandBase, database) {
    var getReplicationSourcesCommand = (function (_super) {
        __extends(getReplicationSourcesCommand, _super);
        function getReplicationSourcesCommand(db) {
            _super.call(this);
            this.db = db;
        }
        getReplicationSourcesCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                startsWith: "Raven/Replication/Sources",
                exclude: null,
                start: 0,
                pageSize: 1024
            };

            return this.query("/docs", args, this.db, function (dtos) {
                var result = {};

                dtos.forEach(function (v) {
                    return result[v.ServerInstanceId] = database.getNameFromUrl(v.Source);
                });

                result[_this.db.statistics().DatabaseId] = _this.db.name;

                return result;
            });
        };
        return getReplicationSourcesCommand;
    })(commandBase);

    
    return getReplicationSourcesCommand;
});
