var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var saveReplicationDocumentCommand = (function (_super) {
        __extends(saveReplicationDocumentCommand, _super);
        function saveReplicationDocumentCommand(dto, db) {
            _super.call(this);
            this.dto = dto;
            this.db = db;
        }
        saveReplicationDocumentCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Replication settings.");
            return this.saveSetup().done(function () {
                return _this.reportSuccess("Saved Replication settings.");
            }).fail(function (response) {
                return _this.reportError("Failed to save Replication settings.", response.responseText, response.statusText);
            });
        };

        saveReplicationDocumentCommand.prototype.saveSetup = function () {
            var id = "Raven/Replication/Destinations";
            var url = "/docs/" + id;
            var putArgs = JSON.stringify(this.dto);
            return this.put(url, putArgs, this.db);
        };
        return saveReplicationDocumentCommand;
    })(commandBase);

    
    return saveReplicationDocumentCommand;
});
