var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "commands/getLicenseStatusCommand"], function(require, exports, commandBase, getLicenseStatusCommand) {
    var saveWindowsAuthCommand = (function (_super) {
        __extends(saveWindowsAuthCommand, _super);
        function saveWindowsAuthCommand(dto) {
            _super.call(this);
            this.dto = dto;
        }
        saveWindowsAuthCommand.prototype.execute = function () {
            return this.fetchLicenseStatus();
        };

        saveWindowsAuthCommand.prototype.fetchLicenseStatus = function () {
            var _this = this;
            return new getLicenseStatusCommand().execute().done(function (result) {
                return _this.handleLicenseStatus(result);
            });
        };

        saveWindowsAuthCommand.prototype.handleLicenseStatus = function (licenseStatus) {
            this.performWithCommercialLicense();
        };

        saveWindowsAuthCommand.prototype.performWithCommercialLicense = function () {
            if (this.dto.RequiredUsers.concat(this.dto.RequiredGroups).every(function (element) {
                return (element.Name.indexOf("\\") !== -1);
            })) {
                this.performSave();
            } else {
                this.reportWarning("Windows Authentication not saved! All names must have \"\\\" in them.");
            }
        };

        saveWindowsAuthCommand.prototype.performSave = function () {
            var _this = this;
            this.reportInfo("Saving Windows Authentication settings.");
            this.saveSetup().done(function () {
                return _this.reportSuccess("Saved Windows Authentication settings.");
            }).fail(function (response) {
                return _this.reportError("Failed to save Windows Authentication settings.", response.responseText, response.statusText);
            });
        };

        saveWindowsAuthCommand.prototype.saveSetup = function () {
            var id = "Raven/Authorization/WindowsSettings";
            var url = "/docs/" + id;
            var putArgs = JSON.stringify(this.dto);
            return this.put(url, putArgs, null);
        };
        return saveWindowsAuthCommand;
    })(commandBase);

    
    return saveWindowsAuthCommand;
});
