﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var verifyDocumentsIDsCommand = (function (_super) {
        __extends(verifyDocumentsIDsCommand, _super);
        function verifyDocumentsIDsCommand(docIDs, db, queryLocalStorage, storeResultsInLocalStorage) {
            _super.call(this);
            this.docIDs = docIDs;
            this.db = db;
            this.queryLocalStorage = queryLocalStorage;
            this.storeResultsInLocalStorage = storeResultsInLocalStorage;

            if (!docIDs) {
                throw new Error("Must specify IDs");
            }

            if (!db) {
                throw new Error("Must specify database");
            }
        }
        verifyDocumentsIDsCommand.prototype.execute = function () {
            var _this = this;
            var verifyResult = $.Deferred();
            var verifiedIDs = [];

            if (this.queryLocalStorage === true) {
                if (!!verifyDocumentsIDsCommand.InvalidIDsLocal && verifyDocumentsIDsCommand.InvalidIDsLocal.length > 0) {
                    this.docIDs.removeAll(verifyDocumentsIDsCommand.InvalidIDsLocal);
                }

                if (!!verifyDocumentsIDsCommand.IDsLocalStorage && verifyDocumentsIDsCommand.IDsLocalStorage.length > 0) {
                    this.docIDs.forEach(function (curId) {
                        if (!!verifyDocumentsIDsCommand.IDsLocalStorage.first(function (x) {
                            return x === curId;
                        })) {
                            verifiedIDs.push(curId);
                        }
                    });

                    this.docIDs.removeAll(verifyDocumentsIDsCommand.IDsLocalStorage);
                }
            }

            if (this.docIDs.length > 0) {
                var postResult = this.post("/queries?metadata-only=true", JSON.stringify(this.docIDs), this.db);
                postResult.fail(function (xhr) {
                    return verifyResult.fail(xhr);
                });
                postResult.done(function (queryResult) {
                    if (!!queryResult && !!queryResult.Results) {
                        queryResult.Results.forEach(function (curVerifiedID) {
                            verifiedIDs.push(curVerifiedID['@metadata']['@id']);
                            if (_this.queryLocalStorage === true) {
                                verifyDocumentsIDsCommand.IDsLocalStorage.push(curVerifiedID);
                            }
                        });

                        if (_this.queryLocalStorage === true) {
                            _this.docIDs.removeAll(queryResult.Results.map(function (curResult) {
                                return curResult['@metadata']['@id'];
                            }));
                            verifyDocumentsIDsCommand.InvalidIDsLocal.pushAll(_this.docIDs);
                        }
                    }
                    verifyResult.resolve(verifiedIDs);
                });
                return verifyResult;
            } else {
                return verifiedIDs;
            }
        };
        verifyDocumentsIDsCommand.IDsLocalStorage = [];
        verifyDocumentsIDsCommand.InvalidIDsLocal = [];
        return verifyDocumentsIDsCommand;
    })(commandBase);

    
    return verifyDocumentsIDsCommand;
});
