﻿define(["require", "exports", "models/filesystem/conflictHistory"], function(require, exports, conflictHistory) {
    var conflictItem = (function () {
        function conflictItem(fileName, remoteServerUrl) {
            this.fileName = fileName;
            this.remoteServerUrl = remoteServerUrl;
            this.remoteHistory = [];
            this.currentHistory = [];
        }
        conflictItem.fromConflictItemDto = function (dto) {
            var item = new conflictItem(dto.FileName, dto.RemoteServerUrl);
            if (dto.RemoteHistory != null) {
                item.remoteHistory.pushAll(dto.RemoteHistory.map(function (x) {
                    return new conflictHistory(x.Version, x.ServerId);
                }));
            }
            if (dto.CurrentHistory != null) {
                item.currentHistory.pushAll(dto.CurrentHistory.map(function (x) {
                    return new conflictHistory(x.Version, x.ServerId);
                }));
            }
            return item;
        };
        return conflictItem;
    })();

    
    return conflictItem;
});
