define(["require", "exports", "common/appUrl", "models/indexPriority"], function(require, exports, appUrl, indexPriority) {
    var index = (function () {
        function index(dto) {
            this.isOnRam = ko.observable();
            this.lockMode = ko.observable();
            this.isIdle = ko.observable(false);
            this.isAbandoned = ko.observable(false);
            this.isDisabled = ko.observable(false);
            this.createdTimestamp = dto.CreatedTimestamp;
            this.docsCount = dto.DocsCount;
            this.forEntityName = dto.ForEntityName;
            this.indexingAttempts = dto.IndexingAttempts;
            this.indexingErrors = dto.IndexingErrors;
            this.indexingSuccesses = dto.IndexingSuccesses;
            this.isOnRam(dto.IsOnRam);
            this.lastIndexedEtag = dto.LastIndexedEtag;
            this.lastIndexedTimestamp = dto.LastIndexedTimestamp;
            this.lastIndexingTime = dto.LastIndexingTime;
            this.lastQueryTimestamp = dto.LastQueryTimestamp;
            this.lastReducedEtag = dto.LastReducedEtag;
            this.lastReducedTimestamp = dto.LastReducedTimestamp;
            this.lockMode(dto.LockMode);
            this.name = dto.PublicName;
            this.performance = dto.Performance;
            this.priority = dto.Priority;
            this.reduceIndexingAttempts = dto.ReduceIndexingAttempts;
            this.reduceIndexingErrors = dto.ReduceIndexingErrors;
            this.reduceIndexingSuccesses = dto.ReduceIndexingSuccesses;
            this.touchCount = dto.TouchCount;

            this.isAbandoned(this.priority && this.priority.indexOf(index.priorityAbandoned) !== -1);
            this.isDisabled(this.priority && this.priority.indexOf(index.priorityDisabled) !== -1);
            this.isIdle(this.priority && this.priority.indexOf(index.priorityIdle) !== -1);
            this.editUrl = appUrl.forCurrentDatabase().editIndex(encodeURIComponent(this.name));
            this.queryUrl = appUrl.forCurrentDatabase().query(this.name);
        }
        index.priorityFromString = function (priority) {
            switch (priority) {
                case index.priorityIdle:
                    return 1 /* idle */;
                case index.priorityDisabled:
                    return 2 /* disabled */;
                case index.priorityAbandoned:
                    return 3 /* abandoned */;
                case index.priorityIdleForced:
                    return 4 /* idleForced */;
                case index.priorityDisabledForced:
                    return 5 /* disabledForced */;
                case index.priorityAbandonedForced:
                    return 6 /* abandonedForced */;
                default:
                    return 0 /* normal */;
            }
        };

        index.priorityToString = function (priority) {
            switch (priority) {
                case 3 /* abandoned */:
                    return index.priorityAbandoned;
                case 6 /* abandonedForced */:
                    return index.priorityAbandonedForced;
                case 2 /* disabled */:
                    return index.priorityDisabled;
                case 5 /* disabledForced */:
                    return index.priorityDisabledForced;
                case 1 /* idle */:
                    return index.priorityIdle;
                case 4 /* idleForced */:
                    return index.priorityIdleForced;
                default:
                    return index.priorityNormal;
            }
        };
        index.priorityNormal = "Normal";
        index.priorityIdle = "Idle";
        index.priorityDisabled = "Disabled";
        index.priorityAbandoned = "Abandoned";
        index.priorityIdleForced = "Idle,Forced";
        index.priorityDisabledForced = "Disabled,Forced";
        index.priorityAbandonedForced = "Abandoned,Forced";
        return index;
    })();

    
    return index;
});
