﻿define(["require", "exports", "common/appUrl"], function(require, exports, appUrl) {
    var transformer = (function () {
        function transformer() {
            var _this = this;
            this.name = ko.observable().extend({ required: true });
            this.transformResults = ko.observable().extend({ required: true });
            this.originalName = ko.observable();
            this.wasNameChanged = ko.computed(function () {
                return _this.name() != _this.originalName();
            });
        }
        transformer.prototype.initFromLoad = function (dto) {
            this.originalName(dto.name.toString());
            this.name(dto.name);
            this.editUrl = appUrl.forCurrentDatabase().editTransformer(encodeURIComponent(this.name()));
            this.transformResults(dto.definition.TransformResults);
            return this;
        };

        transformer.prototype.initFromSave = function (dto) {
            this.originalName(dto.Transformer.Name.toString());
            this.name(dto.Transformer.Name);
            this.editUrl = appUrl.forCurrentDatabase().editTransformer(encodeURIComponent(this.name()));
            this.transformResults(dto.Transformer.TransformResults);
            return this;
        };

        transformer.prototype.toDto = function () {
            return {
                'name': this.name(),
                'definition': {
                    'Name': this.name(),
                    'TransformResults': this.transformResults()
                }
            };
        };

        transformer.prototype.toSaveDto = function () {
            return {
                'Name': this.name(),
                'TransformResults': this.transformResults()
            };
        };

        transformer.empty = function () {
            return new transformer().initFromLoad({
                'name': "",
                'definition': {
                    'Name': "",
                    'TransformResults': ""
                }
            });
        };
        return transformer;
    })();

    
    return transformer;
});
