var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "plugins/dialog", "viewmodels/dialogViewModelBase", "commands/commandBase", "commands/getNewEncryptionKey", "commands/checkEncryptionKey"], function(require, exports, dialog, dialogViewModelBase, commandBase, getNewEncryptionKey, checkEncryptionKey) {
    var createEncryption = (function (_super) {
        __extends(createEncryption, _super);
        function createEncryption() {
            var _this = this;
            _super.call(this);
            this.creationEncryption = $.Deferred();
            this.creationEncryptionStarted = false;
            this.key = ko.observable();
            this.encryptionAlgorithm = ko.observable('Rijndael');
            this.encryptionBits = ko.observable();
            this.isEncryptedIndexes = ko.observable(true);
            this.keyFocus = ko.observable(true);
            this.algorithmFocus = ko.observable(false);
            this.bitsFocus = ko.observable(false);
            this.newCommandBase = new commandBase();

            this.newEncryptionKey = new getNewEncryptionKey();
            this.newEncryptionKey.execute().done(function (result) {
                _this.key(result);
            });
        }
        createEncryption.prototype.cancel = function () {
            dialog.close(this);
        };

        createEncryption.prototype.deactivate = function () {
            if (!this.creationEncryptionStarted) {
                this.creationEncryption.reject();
            }
        };

        createEncryption.prototype.refresh_encryption = function () {
            var _this = this;
            this.newEncryptionKey.execute().done(function (result) {
                _this.key(result);
            });
        };

        createEncryption.prototype.save = function () {
            var _this = this;
            var key = this.key();

            if (this.isClientSideInputOK(key)) {
                var checkEncryption = new checkEncryptionKey(key);
                checkEncryption.execute().done(function (result) {
                    if (Boolean(result)) {
                        _this.creationEncryption.resolve(key, _this.encryptionAlgorithm(), _this.encryptionBits(), _this.isEncryptedIndexes());
                        _this.creationEncryptionStarted = true;
                        dialog.close(_this);
                    }
                });
            }
        };

        createEncryption.prototype.isClientSideInputOK = function (key) {
            var base64Matcher = new RegExp("^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{4})([=]{1,2})?$");
            var result = false;

            if (!key) {
                this.newCommandBase.reportError("Please fill out the key field");
                this.keyFocus(true);
            } else if (!base64Matcher.test(key.toString())) {
                this.newCommandBase.reportError("The key must be in base64 encoding format!");
                this.keyFocus(true);
            } else if (!this.encryptionAlgorithm()) {
                this.newCommandBase.reportError("Please select an encryption algorithm");
                this.algorithmFocus(true);
            } else if (!this.encryptionBits()) {
                this.newCommandBase.reportError("Please select an encryption key bits");
                this.bitsFocus(true);
            } else {
                result = true;
            }
            return result;
        };
        return createEncryption;
    })(dialogViewModelBase);

    
    return createEncryption;
});
