var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/deleteIndexCommand", "plugins/dialog", "viewmodels/dialogViewModelBase"], function(require, exports, deleteIndexCommand, dialog, dialogViewModelBase) {
    var deleteIndexesConfirm = (function (_super) {
        __extends(deleteIndexesConfirm, _super);
        function deleteIndexesConfirm(indexNames, db) {
            _super.call(this);
            this.indexNames = indexNames;
            this.db = db;
            this.deleteTask = $.Deferred();

            if (!indexNames || indexNames.length === 0) {
                throw new Error("Indexes must not be null or empty.");
            }

            this.title = indexNames.length === 1 ? 'Delete index?' : 'Delete indexes?';
        }
        deleteIndexesConfirm.prototype.deleteIndexes = function () {
            var _this = this;
            var deleteTasks = this.indexNames.map(function (name) {
                return new deleteIndexCommand(name, _this.db).execute();
            });

            $.when(deleteTasks).done(function () {
                return _this.deleteTask.resolve();
            });
            dialog.close(this);
        };

        deleteIndexesConfirm.prototype.cancel = function () {
            this.deleteTask.reject();
            dialog.close(this);
        };
        return deleteIndexesConfirm;
    })(dialogViewModelBase);

    
    return deleteIndexesConfirm;
});
