﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "models/document", "models/filesystem/file", "plugins/dialog", "commands/deleteDocumentsCommand", "commands/filesystem/deleteFilesCommand", "common/appUrl", "viewmodels/dialogViewModelBase"], function(require, exports, document, file, dialog, deleteDocumentsCommand, deleteFilesCommand, appUrl, dialogViewModelBase) {
    var deleteItems = (function (_super) {
        __extends(deleteItems, _super);
        function deleteItems(documents, elementToFocusOnDismissal) {
            _super.call(this, elementToFocusOnDismissal);
            this.documents = ko.observableArray();
            this.deletionStarted = false;
            this.deletionTask = $.Deferred();

            if (documents.length === 0) {
                throw new Error("Must have at least one document to delete.");
            }

            this.documents(documents);
        }
        deleteItems.prototype.deleteItems = function () {
            var _this = this;
            var deleteItemsIds = this.documents().map(function (i) {
                return i.getId();
            });
            var deleteCommand;
            if (this.documents()[0] instanceof document) {
                deleteCommand = new deleteDocumentsCommand(deleteItemsIds, appUrl.getDatabase());
            } else if (this.documents()[0] instanceof file) {
                deleteCommand = new deleteFilesCommand(deleteItemsIds, appUrl.getFilesystem());
            }
            var deleteCommandTask = deleteCommand.execute();

            deleteCommandTask.done(function () {
                return _this.deletionTask.resolve(_this.documents());
            });
            deleteCommandTask.fail(function (response) {
                return _this.deletionTask.reject(response);
            });

            this.deletionStarted = true;
            dialog.close(this);
        };

        deleteItems.prototype.cancel = function () {
            dialog.close(this);
        };

        deleteItems.prototype.deactivate = function (args) {
            if (!this.deletionStarted) {
                this.deletionTask.reject();
            }
        };
        return deleteItems;
    })(dialogViewModelBase);

    
    return deleteItems;
});
