define(["require", "exports", "plugins/dialog"], function(require, exports, dialog) {
    var dialogViewModelBase = (function () {
        function dialogViewModelBase(elementToFocusOnDismissal) {
            this.elementToFocusOnDismissal = elementToFocusOnDismissal;
        }
        dialogViewModelBase.prototype.attached = function () {
            var _this = this;
            jwerty.key("escape", function () {
                return dialog.close(_this);
            }, this, dialogViewModelBase.dialogSelector);
            jwerty.key("enter", function () {
                return _this.enterKeyPressed();
            });
            $(dialogViewModelBase.dialogSelector).focus();
        };

        dialogViewModelBase.prototype.detached = function () {
            if (this.elementToFocusOnDismissal) {
                $(this.elementToFocusOnDismissal).focus();
            }

            $(dialogViewModelBase.dialogSelector).unbind('keydown.jwerty');
        };

        dialogViewModelBase.prototype.enterKeyPressed = function () {
            var acceptButton = $(".modal-footer:visible .btn-primary")[0];
            if (acceptButton && acceptButton.click) {
                acceptButton.click();
            }
        };
        dialogViewModelBase.dialogSelector = ".messageBox";
        return dialogViewModelBase;
    })();

    
    return dialogViewModelBase;
});
