﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "viewmodels/dialogViewModelBase", "plugins/dialog", "commands/commandBase"], function(require, exports, dialogViewModelBase, dialog, commandBase) {
    var filesystemAddDestination = (function (_super) {
        __extends(filesystemAddDestination, _super);
        function filesystemAddDestination(destinations) {
            _super.call(this);
            this.creationTask = $.Deferred();
            this.creationTaskStarted = false;
            this.destinationUrl = ko.observable('');
            this.destinationUrlFocus = ko.observable(true);
            this.destinations = ko.observableArray();
            this.newCommandBase = new commandBase();
            this.destinations = destinations;
        }
        filesystemAddDestination.prototype.cancel = function () {
            dialog.close(this);
        };

        filesystemAddDestination.prototype.attached = function () {
            _super.prototype.attached.call(this);
            this.destinationUrl('http://');
            this.destinationUrlFocus(true);
        };

        filesystemAddDestination.prototype.deactivate = function () {
            if (!this.creationTaskStarted) {
                this.creationTask.reject();
            }
        };

        filesystemAddDestination.prototype.add = function () {
            var destinationUrl = this.destinationUrl();

            if (this.isClientSideInputOK(destinationUrl)) {
                this.creationTaskStarted = true;
                this.creationTask.resolve(destinationUrl);
                dialog.close(this);
            }
        };

        filesystemAddDestination.prototype.isClientSideInputOK = function (destinationUrl) {
            var errorMessage = "";

            if (destinationUrl == null) {
                errorMessage = "Please fill out the Destination url field";
            } else if ((errorMessage = this.CheckInput(destinationUrl)) != null) {
            }

            if (errorMessage != null) {
                this.newCommandBase.reportError(errorMessage);
                this.destinationUrlFocus(true);
                return false;
            }
            return true;
        };

        filesystemAddDestination.prototype.CheckInput = function (url) {
            var uriRegex = /(http|https):\/\/(\w+:{ 0, 1}\w*@)?(\S+)(:[0 - 9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;

            var message = null;
            if (!uriRegex.test(url)) {
                message = "The destination url is not valid";
            }

            return message;
        };
        return filesystemAddDestination;
    })(dialogViewModelBase);

    
    return filesystemAddDestination;
});
