﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "plugins/router", "common/appUrl", "viewmodels/viewModelBase", "commands/filesystem/searchByQueryCommand", "common/pagedList"], function(require, exports, router, appUrl, viewModelBase, searchByQueryCommand, pagedList) {
    var filesystemSearch = (function (_super) {
        __extends(filesystemSearch, _super);
        function filesystemSearch() {
            var _this = this;
            _super.call(this);
            this.router = router;
            this.searchUrl = appUrl.forCurrentDatabase().filesystemSearch;
            this.searchText = ko.observable("");
            this.allFilesPagedItems = ko.observable();
            this.selectedFilesIndices = ko.observableArray();

            this.searchText.extend({ throttle: 200 }).subscribe(function (s) {
                return _this.searchFiles(s);
            });
        }
        filesystemSearch.prototype.canActivate = function (args) {
            return true;
        };

        filesystemSearch.prototype.attached = function () {
            $("body").click(function (event) {
                $('.popover-html').each(function (index, value) {
                    var elem = $(value);
                    if (!elem.is(event.target) && elem.has(event.target).length === 0 && $('.popover').has(event.target).length === 0) {
                        elem.popover('hide');
                    }
                });
            });

            var popoverTemplate = '<div class="popover popover-lg"><div class="arrow"></div><div class="popover-inner"><h3 class="popover-title"></h3><div class="popover-content"><p></p></div></div></div>';

            ($('#fileNameEndsWith')).popover({
                html: true,
                content: function () {
                    return $('#fileNameEndsWithContextMenu').html();
                },
                placement: 'bottom'
            });

            ($('#fileNameStartsWith')).popover({
                html: true,
                content: function () {
                    return $('#fileNameStartsWithContextMenu').html();
                },
                placement: 'bottom'
            });

            ($('#fileSizeBetween')).popover({
                html: true,
                content: function () {
                    return $('#fileSizeBetweenContextMenu').html();
                },
                placement: 'bottom',
                template: popoverTemplate
            });

            ($('#hasMetadata')).popover({
                html: true,
                content: function () {
                    return $('#hasMetadataContextMenu').html();
                },
                placement: 'bottom',
                template: popoverTemplate
            });

            ($('#inFolder')).popover({
                html: true,
                content: function () {
                    return $('#inFolderContextMenu').html();
                },
                placement: 'bottom'
            });

            ($('#lastModifiedBetween')).popover({
                html: true,
                content: function () {
                    return $('#lastModifiedBetweenContextMenu').html();
                },
                placement: 'bottom',
                template: popoverTemplate
            });
        };

        filesystemSearch.prototype.searchFiles = function (query) {
            var _this = this;
            var fetcher = function (skip, take) {
                return _this.fetchFiles(query.toLowerCase(), skip, take);
            };
            var list = new pagedList(fetcher);
            this.allFilesPagedItems(list);
        };

        filesystemSearch.prototype.fetchFiles = function (query, skip, take) {
            var task = new searchByQueryCommand(appUrl.getFilesystem(), query, skip, take, null).execute();
            return task;
        };

        filesystemSearch.prototype.fileNameStartsWithClauseBuilder = function (input) {
            this.searchText("__fileName:" + input + "*");
        };
        filesystemSearch.gridSelector = "#filesGrid";
        return filesystemSearch;
    })(viewModelBase);

    
    return filesystemSearch;
});
