﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/stopIndexingCommand", "commands/startIndexingCommand", "commands/getIndexingStatusCommand", "viewmodels/viewModelBase"], function(require, exports, stopIndexingCommand, startIndexingCommand, getIndexingStatusCommand, viewModelBase) {
    var toggleIndexing = (function (_super) {
        __extends(toggleIndexing, _super);
        function toggleIndexing() {
            _super.apply(this, arguments);
            this.indexingStatus = ko.observable("Started");
        }
        toggleIndexing.prototype.disableIndexing = function () {
            var _this = this;
            new stopIndexingCommand(this.activeDatabase()).execute().done(function () {
                return _this.forceModelPolling();
            });
        };

        toggleIndexing.prototype.enableIndexing = function () {
            var _this = this;
            new startIndexingCommand(this.activeDatabase()).execute().done(function () {
                return _this.forceModelPolling();
            });
        };

        toggleIndexing.prototype.modelPolling = function () {
            var _this = this;
            new getIndexingStatusCommand(this.activeDatabase()).execute().done(function (result) {
                return _this.indexingStatus(result.IndexingStatus);
            });
        };
        return toggleIndexing;
    })(viewModelBase);

    
    return toggleIndexing;
});
